
blur_screen:
if 0 ;blur n times  ; blur or fire
;in - ecx  times count
;.counter equ dword[esp-4]
.counter1 equ dword[esp-8]

	 push	    ebp
	 mov	    ebp,esp
	 movups     xmm5,[blur_sub]
     .again_blur:
	 push	    ecx
	 mov	    edi,buffer
	 mov	    ecx,SIZE_X
	 xor	    eax,eax
	 rep	    stosd

	 mov	    ecx,(SIZE_X*(SIZE_Y-4))*4/16
     .blr:
     @@:
	 movups     xmm0,[edi+SIZE_X*4]
	 movups     xmm1,[edi-SIZE_X*4]
	 movups     xmm2,[edi-4]
	 movups     xmm3,[edi+4]

	 pavgb	    xmm0,xmm1
	 pavgb	    xmm2,xmm3
	 pavgb	    xmm0,xmm2

	 psubusb    xmm0,xmm5  ; importand if fire
       int3
	 movups     [edi],xmm0
	 add	    edi,16

	 loop	    .blr

	 xor	    eax,eax
	 mov	    ecx,SIZE_X
	 rep	    stosd
	 pop	    ecx
	 loop	    .again_blur
	 mov	    esp,ebp
	 pop	    ebp
end if
if 0
	 emms
	 push	    ebp
	 mov	    ebp,esp
	 push	    dword 0x01010101
	 push	    dword 0x01010101
	 movq	    mm4,[esp]
     .again_blur:
	 push	    ecx
	 mov	    edi,buffer
	 mov	    ecx,SIZE_X/4
     ;    pxor       mm5,mm5
	 xor	    eax,eax
	 rep	    stosd

	 mov	    ecx,(SIZE_X*(SIZE_Y-4))/8
     .blr:
     @@:
	 movq	    mm0,[edi+SIZE_X*4]
	 movq	    mm1,[edi-SIZE_X*4]
	 movq	    mm2,[edi-4]
	 movq	    mm3,[edi+4]

	 pavgb	    mm0,mm1
	 pavgb	    mm2,mm3
	 pavgb	    mm0,mm2

	 psubusb    mm0,mm4  ; importand if fire

	 movq	    [edi],mm0
	 add	     edi,8
	 add	     esi,8

	 loop	     .blr

	 xor	    eax,eax
	 mov	    ecx,SIZE_X/4
	 rep	    stosd
	 pop	     ecx
	 loop	    .again_blur
	 mov	    esp,ebp
	 pop	    ebp


ret
end if



generate_texture2:
.const equ 32
	mov	edi,texmap
	xor	bx,bx
     .next_line:
	xor	dx,dx
     .next2stripes:
	mov	eax,-1
	mov	ecx,(TEX_X/.const)
	rep	stosd
	mov	eax,0x00ff0000
	mov	ecx,(TEX_X/.const)
     @@:
	stosd
	loop	@b
	inc	dx
	cmp	dx,.const/2
	jl	.next2stripes
	inc	bx
	cmp	bx,TEX_Y
	jl	.next_line
ret



calc_bumpmap_coords:	  ; map texture, bump

      fninit
      fldpi
      fadd	st,st
      mov	esi,points_r
      mov	edi,tex_points
      movzx	ecx,[points_count_var]
      inc	ecx
;      cmp       [map_tex_flag],1
;      jne       .cylindric
      ; spherical mapping around y axle

   @@:
      fld	dword[esi]     ; x coord
      fld	dword[esi+8]   ; z coord
      fpatan		       ; arctg(st1/st)
;      fdiv      .Pi2
      fdiv	st0,st1
      fimul	[tex_x_div2]
      fiadd	[tex_x_div2]
      fistp	word[edi]      ; x

      fld	dword[esi+4]   ; y coord
      fld	dword[esi]     ; x
      fmul	st,st0
      fld	dword[esi+4]   ; y
      fmul	st,st0
      fld	dword[esi+8]   ; z
      fmul	st,st0
      faddp
      faddp
      fsqrt
      fpatan
      fldpi
      fdivp
      fimul    [tex_y_div2]
      fiadd    [tex_y_div2]
      fistp    word[edi+2]     ; y

      add      esi,12
      add      edi,4
      loop     @b
      ffree    st0

ret



calc_bumpmap:		 ; calculate random bumpmap
;--------------in edi _ pointer to TEX_X x TEX_Y bumpmap

	 push	 edi

;         cmp     [bumps_flag],0
;         je      .random_bump_map
	 ; else bumps according to texture
;         mov     esi,texmap
;         mov     ecx,TEXTURE_SIZE
;      @@:
;         movzx   ax,byte[esi]
;         movzx   bx,byte[esi+1]
;         movzx   dx,byte[esi+2]
;         add     ax,bx
;         add     ax,dx
;         cwd
;         div     [i3]
;         stosb
;         add     esi,3
;         loop    @b
;         jmp     .blur_map

;         push    ecx
;         mov     eax,0x88888888
;         mov     ecx,16/4
;         rep     stosd
;         mov     eax,0xffffffff
;         mov     ecx,16/4
;         rep     stosd
;         pop     ecx
;         loop    @b
;  .random_bump_map:

	 mov	 ecx,TEXTURE_SIZE
  ;       RDTSC
  ;       mov    [rand_seed],ax
      @@:
	 push	 ecx
	 xor	 ecx,ecx
	 mov	 edx,255
	 call	 random
	 stosb
	 pop	ecx
	 loop	@b

      .blur_map:
	 pop	edi
      ;   movzx  ecx,[bumps_deep_flag]
	 mov	ecx,4
      ;   inc    cx
      .blur:
	 xor	esi,esi
	 mov	edx,TEXTURE_SIZE
	 xor	eax,eax
	 xor	ebx,ebx
      @@:
	 mov	ebp,esi
	 dec	ebp
	 and	ebp,TEXTURE_SIZE
	 mov	al,byte[ebp+edi]

	 mov	ebp,esi
	 inc	ebp
	 and	ebp,TEXTURE_SIZE
	 mov	bl,byte[ebp+edi]
	 add	eax,ebx

	 mov	ebp,esi
	 sub	ebp,TEX_X
	 and	ebp,TEXTURE_SIZE
	 mov	bl,byte[ebp+edi]
	 add	eax,ebx

	 mov	ebp,esi
	 add	ebp,TEX_X
	 and	ebp,TEXTURE_SIZE
	 mov	bl,byte[ebp+edi]
	 add	eax,ebx

	 shr	eax,2
	 mov	byte[esi+edi],al

	 inc	esi
	 dec	edx
	 jnz	@b

	 loop	.blur
ret


make_random_lights:
  .temp1  equ ebp-4
  .temp2  equ ebp-8	;  - light vector generate variables
  .temp3  equ ebp-12
  .max equ 800
	RDTSC
	mov    [rand_seed],ax
	push	ebp
	mov	ebp,esp
	sub	esp,12
	mov	edi,lights
	fninit
	mov	dword[.temp2],.max
	mov	dword[.temp3],.max/2

    .again:
	xor	esi,esi
     @@:
	mov	edx,.max
	xor	ecx,ecx
	call	random
	sub	eax,.max/2
	mov	dword[.temp1],eax
	fild	dword[.temp1]
	fidiv	dword[.temp3]
	fstp	dword[edi+esi*4]
	inc	esi
	cmp	esi,2
	jne	@b

  .max1 equ 1000
	mov	dword[.temp2],.max1/2
	mov	edx,.max1
	xor	ecx,ecx
	call	random
	mov	dword[.temp1],eax
	fild	dword[.temp1]
	fchs
	fidiv	dword[.temp2]
	fstp	dword[edi+8]

	xor	esi,esi
     @@:
	mov	ecx,220 	   ; max colors and shine  , ecx = 200 - more bright shading
	mov	edx,255
	call	random
	movzx	ax,al
	mov	[edi+28+esi*2],ax
	inc	esi
	cmp	esi,4
	jne	@b

	xor	esi,esi
     @@:
	mov	ecx,100 	     ; orginal colors
	movzx	edx,word[edi+28+esi*2]
	call	random
	movzx	ax,al
	mov	[edi+12+esi*2],ax
	inc	esi
	cmp	esi,3
	jne	@b

	xor	esi,esi
     @@:
	mov	ecx,1		    ; min cols
	movzx	edx,word[edi+12+esi*2]
	call	random
	movzx	ax,al
	mov	[edi+20+esi*2],ax
	inc	esi
	cmp	esi,3
	jne	@b

	add	edi,LIGHT_SIZE ;22
	cmp	edi,lightsend
	jne	.again

	mov	esp,ebp
	pop	ebp
ret

random:
;  in  - ecx - min
;        edx - max
;  out - eax - random number
	 mov	bx,[rand_seed]
	 add	bx,0x9248
	 ror	bx,3
	 mov	[rand_seed],bx

	 mov	ax,dx
	 sub	ax,cx
	 mul	bx
	 mov	ax,dx
	 add	ax,cx
	 cwde
ret

do_color_buffer:	 ; do color buffer for Gouraud, flat shading
;env_map 512 x 512 x 3 bytes    ; many lights using
.temp  equ word   [ebp-2]
.nz    equ dword  [ebp-6]  ; dword
.ny    equ dword  [ebp-10]
.nx    equ dword  [ebp-14]
.col_r equ    [ebp-16]
.col_g equ    [ebp-17]
.col_b equ    [ebp-18]

	 push	  ebp
	 mov	  ebp,esp
	 sub	  esp,20
	 mov	  edi,color_map
	 fninit

	 mov	  dx,- TEX_Y / 2 ;-256   ; dx - vertical coordinate = y
    .ie_ver:
	 mov	  cx,- TEX_X / 2 ;256   ; cx - horizontal coord = x
    .ie_hor:
	 mov	  .temp,cx
	 fild	  .temp
	 fidiv	  [tex_x_div2];[i256]st = Nx - vector normal x cooficient
	 fst	  .nx
	 fmul	  st,st0
	 mov	  .temp,dx
	 fild	  .temp
	 fidiv	  [tex_y_div2];[i256]st = Ny - vector normal y coeficient
	 fst	  .ny
	 fmul	  st,st0
	 faddp
	 fld1
	 fchs
	 faddp
	 fabs
	 fsqrt
	 fchs
	 fstp	  .nz		   ; st - Nz - vect normal z coeficient
	 xor	  ebx,ebx
	 mov	  dword .col_b, 0
     .light:
	 push	  edi	;env_map
	 lea	  esi,[lights+ebx]
	 lea	  edi,.nx
	 call	  dot_product
	 pop	  edi
	 fcom	  [dot_min]
	 fstsw	  ax
	 sahf
	 ja	  .env_ok1  ;compare with dot_max
	 ffree	  st

	jmp	  .update_counters
      .env_ok1:
	 fcom	 [dot_max]
	 fstsw	 ax
	 sahf
	 jb	 .env_ok2     ; calc col
	 ffree	 st
	 jmp	 .update_counters
      .env_ok2: 	   ;calc col
	 push	  ebp
	 push	  word[esi+36]	 ; -  shines
	 push	  word[esi+12]	 ; b  orginal color
	 push	  word[esi+14]	 ; g
	 push	  word[esi+16]	 ; r
	 push	  word[esi+28]	 ; b  max color
	 push	  word[esi+30]	 ; g
	 push	  word[esi+32]	 ; r
	 push	  word[esi+20]	 ; b  min col
	 push	  word[esi+22]	 ; g
	 push	  word[esi+24]	 ; r
	 push	  eax	      ; earlier - dot pr
      ;  fstp     .dot_product
      ;  push     .dot_product
	 call	  calc_one_col
	 pop	  ebp
	 ; eax-0x00rrggbb
	 cmp	  al,.col_b
	 jbe	  @f
	 mov	  .col_b,al
   @@:
	 shr	  ax,8
	 cmp	  al,.col_g
	 jbe	  @f
	 mov	  .col_g,al
   @@:
	 shr	  eax,16
	 cmp	  al,.col_r
	 jbe	  @f
	 mov	  .col_r,al
  @@:
 .update_counters:				    ; update and jump when neccesery
	add	ebx,LIGHT_SIZE
	cmp	bx,[all_lights_size]
	jl	.light	  ; next_light
	mov	eax,dword .col_b
	stosd

	inc	cx
	cmp	cx,TEX_X / 2 ;256
	jne	.ie_hor

	inc	dx
	cmp	dx,TEX_X / 2 ;256
	jne	.ie_ver

    .env_done:
	 mov	 esp,ebp
	 pop	 ebp
ret




init_envmap2:	      ; do env_map
;env_map 512 x 512 x 4 bytes
.temp  equ word   [ebp-2]
.nEy   equ word   [ebp-4]
.nEx   equ word   [ebp-6]
.col_r equ	  [ebp-8]
.col_g equ	  [ebp-9]
.col_b equ	  [ebp-10]

	 push	  ebp
	 mov	  ebp,esp
	 sub	  esp,20
	 mov	  edi,envmap
	 fninit

	 mov	  dx,- TEX_Y / 2 ;256   ; dx - vertical coordinate = y
    .ie_ver:
	 mov	  cx,- TEX_X / 2 ;256   ; cx - horizontal coord = x
    .ie_hor:
	 xor	  ebx,ebx
	 mov	  dword .col_b, 0
     .light:
	 lea	  esi,[lights+ebx]
	 fld	  dword[esi]	 ; light vector x cooficient
	 fimul	  [tex_x_div2] ;[i256]
	 mov	  .temp,cx
	 fisubr   .temp
	 fistp	  .nEx
	 fld	  dword[esi+4]	 ; light vector y cooficient
	 fimul	  [tex_y_div2] ;[i256]
	 mov	  .temp,dx
	 fisubr   .temp
	 fistp	  .nEy

	 cmp	  .nEx,- TEX_X / 2 ;256
	 jl	  .update_counters
	 cmp	  .nEy,- TEX_Y / 2 ;256
	 jl	  .update_counters
	 cmp	  .nEx,TEX_X / 2 ;256
	 jg	  .update_counters
	 cmp	  .nEy,TEX_Y / 2 ;256
	 jg	  .update_counters

	 fild	  .nEx
	 fmul	  st,st0
	 fild	  .nEy
	 fmul	  st,st0
	 faddp
	 fsqrt
	 fisubr   [i256]
	 fmul	  [env_const]
	 fidiv	  [i256]   ; st - 'virtual' dot product

	 fcom	  [dot_max]
	 fstsw	  ax
	 sahf
	 jb	  @f
	 ffree	  st
	 fld1	  ;[dot_max]
      @@:
	 fcom	  [dot_min]
	 fstsw	  ax
	 sahf
	 ja	  @f
	 ffree	  st
	 fldz	  ;[dot_min]
      @@:
	 push	  ebp
	 push	  word[esi+36]	 ; -  shines
	 push	  word[esi+12]	 ; b  orginal color
	 push	  word[esi+14]	 ; g
	 push	  word[esi+16]	 ; r
	 push	  word[esi+28]	 ; b  max color
	 push	  word[esi+30]	 ; g
	 push	  word[esi+32]	 ; r
	 push	  word[esi+20]	 ; b  min col
	 push	  word[esi+22]	 ; g
	 push	  word[esi+24]	 ; r
	 push	  eax		 ;    earlier - dot pr
      ;  fstp     .dot_product
      ;  push     .dot_product
	 call	  calc_one_col
	 pop	  ebp
	 ; eax-0x00rrggbb
	 cmp	  al,.col_b
	 jbe	  @f
	 mov	  .col_b,al
   @@:			      ;  eax - ggbb00rr
	 shr	  ax,8
	 cmp	  al,.col_g
	 jbe	  @f
	 mov	  .col_g,al
   @@:			      ;  eax - bb0000gg
	 shr	  eax,16
	 cmp	  al,.col_r
	 jbe	  @f
	 mov	  .col_r,al
   @@:
   .update_counters:			 ; update and jump when neccesery
	 add	  ebx,LIGHT_SIZE
	 cmp	  bx,[all_lights_size]
	 jl	  .light    ; next_light
	 mov	  eax,dword .col_b
	 or	   eax,0xff000000
	 stosd
     ;    dec      edi

	 inc	  cx
	 cmp	  cx,TEX_X / 2 ;256
	 jne	  .ie_hor

	 inc	  dx
	 cmp	  dx,TEX_Y / 2 ;256
	 jne	 .ie_ver

	 mov	 esp,ebp
	 pop	 ebp
ret


  calc_one_col:
; procedure don't save registers !!!
; in -   st - dot_product
;        stack - other parameters
; out - eax - 0x00rrggbb
.dot_prd   equ dword[ebp+4]	      ; dot product   - cos x  - not now
.min_col_r equ word[ebp+8]	      ; minimum color - ambient
.min_col_g equ word[ebp+10]
.min_col_b equ word[ebp+12]
.max_col_r equ word[ebp+14]	      ; maximum color - specular
.max_col_g equ word[ebp+16]
.max_col_b equ word[ebp+18]
.org_col_r equ word[ebp+20]	      ; orginal color - diffuse
.org_col_g equ word[ebp+22]
.org_col_b equ word[ebp+24]
.n	   equ word[ebp+26]	      ; shines - not implemented
.temp	   equ word[ebp-2]
.color_sum_r equ dword[ebp-6]
.color_sum_g equ dword[ebp-10]
.color_sum_b equ dword[ebp-14]
; color = ambient+cos(x)*diffuse+(cos(x)^n)*specular
	 mov	 ebp,esp
	 sub	 esp,14

	 mov	  ax,.min_col_r
	 add	  ax,.max_col_r
	 add	  ax,.org_col_r
	 cwde
	 mov	  .color_sum_r,eax

	 mov	  ax,.min_col_g
	 add	  ax,.max_col_g
	 add	  ax,.org_col_g
	 cwde
	 mov	  .color_sum_g,eax

	 mov	  ax,.min_col_b
	 add	  ax,.max_col_b
	 add	  ax,.org_col_b
	 cwde
	 mov	  .color_sum_b,eax


;         fld     .dot_prd
       ;  fild    .n
       ;  fxch    st1
       ;  fabs
       ;  fyl2x                     ;
       ;  f2xm1
       ;  fld1
       ;  faddp        ; st =  dot_product ^ n

	 fld	 st	       ; copy dot pr
	 fmul	 st,st0
	 fmul	 st,st0
	 fmul	 st,st0
	 cmp	 .n,255 	   ; .n = 255 -> spot light
	 jne	 @f
	 fmul	 st,st0
	 fmul	 st,st0
	 fmul	 st,st0
      @@:
	 fld	 st	       ; st0=st1=dot_pr^n, st2=dot_pr
	 fimul	 .max_col_b
	 fild	 .org_col_b
	 fmul	 st,st3
	 faddp		       ; st0=first piece of col, st1=dot_pr^n..
	 fiadd	 .min_col_b
	 fimul	 .max_col_b
	 fidiv	 .color_sum_b
	 fistp	 .temp
	 movzx	 eax,.temp
	 shl	 eax,16

	 fld	 st
	 fimul	 .max_col_g
	 fild	 .org_col_g
	 fmul	 st,st3
	 faddp
	 fiadd	 .min_col_g
	 fimul	 .max_col_g
	 fidiv	 .color_sum_g
	 fistp	 .temp
	 mov	 ax,.temp
	 mov	 ah,al
	 shl	 eax,8

	 fimul	 .max_col_r
	 fild	 .org_col_r
	 fmulp	 st2,st
	 faddp
	 fiadd	 .min_col_r
	 fimul	 .max_col_r
	 fidiv	 .color_sum_r
	 fistp	 .temp
	 mov	 ax,.temp	   ;eax -  0xbbgg00rr
     ;   mov     ah,al
	 ror	 eax,16
	 xchg	 al,ah		   ; eax - 0x00rrggbb
	 mov	 esp,ebp
ret 24
